package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.GameMode;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.OP, source = SourceType.BOTH)
@CommandParameters(description = "Quickly change your own gamemode to adventure, define someone's username to change theirs, or change everyone's gamemode on the server.", usage = "/<command> <[partialname] | -a>", aliases = "gma")
public class Command_adventure extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            if (isConsole())
            {
                msgNew("When used from the console, you must define a target player.");
                return true;
            }

            playerSender.setGameMode(GameMode.ADVENTURE);
            msgNew("Your gamemode has been set to adventure.");
            return true;
        }

        checkRank(Rank.ADMIN);

        if (args[0].equals("-a"))
        {
            FUtil.adminAction(sender.getName(), "Changing everyone's gamemode to adventure", false);

            server.getOnlinePlayers().forEach(player ->
            {
                player.setGameMode(GameMode.ADVENTURE);
                msgNew("Your gamemode has been set to adventure.");
            });

            return true;
        }

        Player player = getPlayer(args[0]);

        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        msgNew("Setting <player> to game mode adventure.", Placeholder.unparsed("player", player.getName()));
        player.setGameMode(GameMode.ADVENTURE);
        msgNew(player, "<sender> set your game mode to adventure.", Placeholder.unparsed("sender", sender.getName()));

        return true;
    }
}