package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.banning.Ban;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.ADMIN, source = SourceType.BOTH, blockHostConsole = true)
@CommandParameters(description = "Bans the specified ip.", usage = "/<command> <ip> [reason] [-q]")
public class Command_banip extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            return false;
        }

        boolean silent = false;

        String reason = null;

        String ip = args[0];

        if (FUtil.isValidIPv4(ip))
        {
            msgNew("<red><ip> is not a valid IP address.", Placeholder.unparsed("ip", ip));
            return true;
        }

        if (plugin.bm.getByIp(ip) != null)
        {
            msgNew("<red>The IP <ip> is already banned.", Placeholder.unparsed("ip", ip));
            return true;
        }

        if (args[args.length - 1].equalsIgnoreCase("-q"))
        {
            silent = true;

            if (args.length >= 2)
            {
                reason = StringUtils.join(ArrayUtils.subarray(args, 1, args.length - 1), " ");
            }
        }
        else if (args.length > 1)
        {
            reason = StringUtils.join(ArrayUtils.subarray(args, 1, args.length), " ");
        }

        // Ban player
        Ban ban = Ban.forPlayerIp(ip, sender, null, reason);
        plugin.bm.addBan(ban);

        // Kick player and handle others on IP
        server.getOnlinePlayers().stream().filter(player -> FUtil.getIp(player).equalsIgnoreCase(ip)).forEach(player ->
                player.kickPlayer(ban.bakeKickMessage()));

        // Broadcasts the message
        if (!silent)
        {
            plugin.cm.broadcastSplit("<red><sender> - Banned the IP <ip>", "<red><sender> - Banned an IP", Placeholder.unparsed("ip", ip));
        }

        return true;
    }
}