package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.Collections;
import java.util.List;

@CommandPermissions(rank = Rank.OP, source = SourceType.BOTH)
@CommandParameters(description = "Shows all banned player names. Admins may optionally use 'purge' to clear the list.", usage = "/<command> [purge]")
public class Command_banlist extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length > 0)
        {
            if (args[0].equalsIgnoreCase("purge"))
            {
                checkRank(Rank.SENIOR_ADMIN);
                FUtil.adminAction(sender.getName(), "Purging the ban list", true);
                msgNew("<green>Purged <amount> player bans.", Placeholder.unparsed("amount", String.valueOf(plugin.bm.purge())));
                return true;
            }
            return false;
        }

        msgNew("<total> player bans (<usernames> usernames, <ips> IPs)",
                Placeholder.unparsed("total", String.valueOf(plugin.bm.getAllBans().size())),
                Placeholder.unparsed("usernames", String.valueOf(plugin.bm.getUsernameBans())),
                Placeholder.unparsed("ips", String.valueOf(plugin.bm.getIpBans().size())));
        return true;
    }

    @Override
    protected List<String> getTabCompleteOptions(CommandSender sender, Command command, String alias, String[] args)
    {
        return args.length == 1 && plugin.al.isSeniorAdmin(sender) ? Collections.singletonList("purge") : Collections.emptyList();
    }
}