package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.player.FPlayer;
import me.totalfreedom.totalfreedommod.punishments.Punishment;
import me.totalfreedom.totalfreedommod.punishments.PunishmentType;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.ADMIN, source = SourceType.BOTH)
@CommandParameters(description = "Block all commands for everyone on the server, or a specific player.", usage = "/<command> <-a | purge | <player>>", aliases = "blockcommands,blockcommand,bc,bcmd")
public class Command_blockcmd extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length != 1)
        {
            return false;
        }

        if (args[0].equals("purge"))
        {
            FUtil.adminAction(sender.getName(), "Unblocking commands for all players", true);
            int counter = 0;
            for (Player player : server.getOnlinePlayers())
            {
                FPlayer playerdata = plugin.pl.getPlayer(player);
                if (playerdata.allCommandsBlocked())
                {
                    counter += 1;
                    playerdata.setCommandsBlocked(false);
                }
            }

            msgNew("Unblocked commands for <count> players.", Placeholder.unparsed("count", String.valueOf(counter)));
            return true;
        }

        if (args[0].equals("-a"))
        {
            FUtil.adminAction(sender.getName(), "Blocking commands for all non-admins", true);
            int counter = 0;
            for (Player player : server.getOnlinePlayers())
            {
                if (isAdmin(player))
                {
                    continue;
                }

                counter += 1;
                plugin.pl.getPlayer(player).setCommandsBlocked(true);
                msgNew(player, "<red>Your commands have been blocked by an admin.");
            }

            msgNew("Blocked commands for <count> players.", Placeholder.unparsed("count", String.valueOf(counter)));
            return true;
        }

        final Player player = getPlayer(args[0]);

        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        if (isAdmin(player))
        {
            msgNew("<player> is an admin, and cannot have their commands blocked.", Placeholder.unparsed("player", player.getName()));
            return true;
        }

        FPlayer playerdata = plugin.pl.getPlayer(player);
        if (!playerdata.allCommandsBlocked())
        {
            FUtil.adminAction(sender.getName(), "Blocking all commands for " + player.getName(), true);
            playerdata.setCommandsBlocked(true);
            msgNew("Blocked commands for <player>.", Placeholder.unparsed("player", player.getName()));

            plugin.pul.logPunishment(new Punishment(player.getName(), FUtil.getIp(player), sender.getName(), PunishmentType.BLOCKCMD, null));
        }
        else
        {
            msgNew("<red>That player's commands are already blocked.");
        }
        return true;
    }
}