package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.GameMode;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.OP, source = SourceType.BOTH)
@CommandParameters(description = "Quickly change your own gamemode to creative, define someone's username to change theirs, or change everyone's gamemode on the server.", usage = "/<command> <-a | [partialname]>", aliases = "gmc")
public class Command_creative extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            if (isConsole())
            {
                msgNew("When used from the console, you must define a target player.");
                return true;
            }

            playerSender.setGameMode(GameMode.CREATIVE);
            msgNew("Your gamemode has been set to creative.");
            return true;
        }

        checkRank(Rank.ADMIN);

        if (args[0].equals("-a"))
        {
            FUtil.adminAction(sender.getName(), "Changing everyone's gamemode to creative", false);

            server.getOnlinePlayers().forEach(player ->
            {
                player.setGameMode(GameMode.CREATIVE);
                msgNew(player, "Your gamemode has been set to creative.");
            });

            return true;
        }

        Player player = getPlayer(args[0]);

        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        msgNew("Setting <player> to gamemode creative.", Placeholder.unparsed("player", player.getName()));
        msgNew(player, "<sender> set your gamemode to creative.", Placeholder.unparsed("sender", sender.getName()));
        player.setGameMode(GameMode.CREATIVE);
        return true;
    }
}