package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.banning.Ban;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.ADMIN, source = SourceType.BOTH)
@CommandParameters(description = "Unbans the specified IP.", usage = "/<command> <ip> [-q]")
public class Command_unbanip extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            return false;
        }

        boolean silent = false;

        String ip = args[0];

        if (FUtil.isValidIPv4(ip))
        {
            msgNew("<red><ip> is not a valid IP address.", Placeholder.unparsed("ip", ip));
            return true;
        }

        Ban ban = plugin.bm.getByIp(ip);

        if (ban == null)
        {
            msgNew("<red><ip> is not a banned IP address.", Placeholder.unparsed("ip", ip));
            return true;
        }

        if (ban.hasUsername())
        {
            msgNew("<red>This ban is not an IP-only ban.");
            return true;
        }

        if (args.length > 1 && args[1].equals("-q"))
        {
            silent = true;
        }

        plugin.bm.removeBan(ban);

        if (!silent)
        {
            plugin.cm.broadcastSplit("<red><sender> - Unbanned the IP <ip>", "<red><sender> - Unbanned an IP",
                    Placeholder.unparsed("sender", sender.getName()),
                    Placeholder.unparsed("ip", ip));
        }

        return true;
    }
}