package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.player.PlayerData;
import me.totalfreedom.totalfreedommod.rank.Rank;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.OP, source = SourceType.ONLY_IN_GAME)
@CommandParameters(description = "Unlink your Discord account from your Minecraft account", usage = "/<command> [player]")
public class Command_unlinkdiscord extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (plugin.dc == null || !plugin.dc.isEnabled())
        {
            msgNew("<red>The Discord integration system is currently disabled.");
            return true;
        }

        if (args.length != 0 && plugin.al.isAdmin(playerSender))
        {
            PlayerData playerData = plugin.pl.getData(args[0]);
            if (playerData == null)
            {
                msg(PLAYER_NOT_FOUND);
                return true;
            }

            playerData.setDiscordID(null);
            msgNew("<green>Unlinked <player>'s Discord account.", Placeholder.unparsed("player", playerData.getName()));
            return true;
        }

        PlayerData data = plugin.pl.getData(playerSender);
        if (data.getDiscordID() == null)
        {
            msgNew("<red>Your Minecraft account is not linked to a Discord account.");
            return true;
        }
        data.setDiscordID(null);
        plugin.pl.save(data);
        msgNew("<green>Your Minecraft account has been successfully unlinked from the Discord account.");
        return true;
    }
}