package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.player.FPlayer;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.apache.commons.lang3.ArrayUtils;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.ADMIN, source = SourceType.BOTH)
@CommandParameters(description = "Unmutes a player", usage = "/<command> [-q] <player>")
public class Command_unmute extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            return false;
        }

        // -q option (shadowmute)
        boolean quiet = args[0].equals("-q");
        if (quiet)
        {
            args = ArrayUtils.subarray(args, 1, args.length);

            if (args.length < 1)
            {
                return false;
            }
        }

        final Player player = getPlayer(args[0]);
        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        FPlayer playerdata = plugin.pl.getPlayer(player);
        if (playerdata.isMuted())
        {
            playerdata.setMuted(false);
            FUtil.playerTitle(sender, "<red>You have been unmuted.", "<yellow>Be sure to follow the rules!");
            msgNew("<green>You have been unmuted.");

            if (quiet)
            {
                msgNew("Quietly unmuted <player>.", Placeholder.unparsed("player", player.getName()));
                return true;
            }
            else
            {
                FUtil.adminAction(sender.getName(), "Unmuting " + player.getName(), true);
                msgNew("Unmuted <player>.", Placeholder.unparsed("player", player.getName()));
            }
        }
        else
        {
            msgNew("<red>That player is not muted.");
        }

        return true;
    }
}